<template>
  <q-card outlined draggable="true" class="card column text-center" @dragstart="handle_dragstart" :style="card_style">
    <span class="name text-subtitle1">{{ name }}</span>
    <q-img :src="image_path" class="image" fit="contain">
      <template v-slot:error>
        <q-img :src="fallback_image_path" fit="contain" class="image absolute-full bg-white"  />
      </template>
    </q-img>
    <q-tooltip anchor="top middle" self="bottom middle" :delay="500" :offset="[0, 10]">{{
      $props.node.name
    }}</q-tooltip>
  </q-card>
</template>

<script lang="ts">
import { defineComponent, PropType, computed } from 'vue';
import { Node } from 'src/models/workflow';

export default defineComponent({
  props: {
    node: {
      type: Object as PropType<Node>,
      default: () => {
        return {
          name: 'Default',
          family: 'none',
          inputs: [],
          outputs: [],
          loggable: [],
          data: [],
        } as Node;
      },
    },
  },

  setup(props) {
    const name = computed(() => {
      const _name = props.node.name;
      return _name.length > 11 ? _name.slice(0, 11) + '.' : _name;
    });

    const handle_dragstart = (e: DragEvent) => {
      e.dataTransfer?.setData('text/plain', `${props.node.family}/${props.node.name}`);
    };

    let image_path = `workflow/${props.node.family}/${props.node.name.toLowerCase()}.svg`;
    let fallback_image_path = `workflow/${props.node.family}/fallback.svg`;

    if (props.node.family === 'testbed') {
      image_path = `workflow/testbed/testbed${props.node.inputs.length}.svg`;
    }

    const card_style = computed(() => {
      let color0 = '#333333';
      let color1 = '#FFFFFF';
      switch (props.node.family) {
        case 'controller':
          color0 = '#2980b9';
          color1 = '#93cef5';
          break;
        case 'reference':
          color0 = '#1abc9c';
          color1 = '#a1f7e6';
          break;
        case 'testbed':
          color0 = '#333333';
          color1 = '#dedede';
          break;
      }
      return {
        border: 'solid 2px transparent',
        'border-image': `linear-gradient(to bottom right, ${color1} 0%, ${color0} 100%)`,
        'border-image-slice': 1,
      };
    });

    return {
      handle_dragstart,
      card_style,
      name,
      image_path,
      fallback_image_path,
    };
  },
});
</script>

<style lang="sass" scoped>

.card
  width: 110px
  height: 105px
  margin: auto
  margin-top: 24px

  .name
    height: 24px
    padding-top: 0px
    padding-bottom: 0px

  .image
    padding: 0px
    max-width: 60%
    max-height: 70px
    margin: auto
</style>
